<?php
require_once('eqtext2html.php');

if ( isset($_GET['source']) ) {
  $source = $_GET['source'];
  if ( get_magic_quotes_gpc() ) {
    $source = stripslashes($source);
  }
} else {
  // An example
  $source = 'This is an example.  Inline variables $x$ and $z$.  An equation in display math mode $$y = ax^2 + bx + c$$';
}

$execlog = '';
$html = eqtext2html($source, $execlog);

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>LaTeXEq</title>
<style type="text/css">
.box { 
  width: 450px; 
  border: 1px solid black;
  padding: 0.5em;
}
textarea { font-family: "Courier New" monospace; font-size: 15px; }
.dmath { margin-left: 3em; }
</style>
<body>

<div style="float:right; width:10em">
<p style="text-align:right">
  <a href="http://validator.w3.org/check/referer">
  <img border="0" src="http://www.w3.org/Icons/valid-html401"
    alt="Valid HTML 4.01!" height="31" width="88"></a>
</p>
<address style="text-align:right">
  Author<br>Tero Tilus<br>
  <a href="mailto:terotil@jyu.fi">terotil@jyu.fi</a>
</address>
</div>

<h1>LaTeXEq</h1>

<p>Write EqText (ordinary text with with (La)TeX math environments) in
the "Source" -box.  LaTeX math (<tt>$..$</tt>) and displaymath
(<tt>$$..$$</tt>) environments are converted to images.</p>

<h2>EqText</h2>

<form method="GET" action="<?php echo $_SERVER['PHP_SELF'];?>">
<textarea name="source" rows="6" cols="50"><?php echo htmlspecialchars($source);?></textarea><br>
<input type="submit" value="Process">
</form>

<h2>Execution log</h2>

<form action="#">
<textarea name="log" rows="6" cols="50"><?php echo htmlspecialchars($execlog); ?></textarea>
</form>

<h2>Result</h2>

<div class="box"><div>
<?php echo $html; ?>
</div></div>

<h2>Source</h2>

<p>
<a href="buffered_system.phps">buffered_system.php</a><br>
<a href="eqtext2html.phps">eqtext2html.php</a><br>
<a href="index.phps">index.php</a><br>
<a href="latex2img.txt">latex2img</a>
</p>

</body>
</html>
