<?php
/****************************************************************************
 * Copyright 2002, Tero Tilus <tero@tilus.net>
 *
 * This php class is distributed under the terms of the GNU General
 * Public License <http://www.gnu.org/licenses/gpl.html> and WITHOUT
 * ANY WARRANTY.
 **/

/****************************************************************************
 * CGI related functions
 **/ 
class CGI {

  /**************************************************************************
   * Return name of global array containing given set of predefined variables
   * $array = 'get', 'post', 'cookie', 'env', 'server'
   */
  function getArrayName($array) {
    // Old style $HTTP_*_VARS arrays should be available
    return strtoupper("http_$array_vars");
    /* FIXME Is this unneeded in every case?
    $arrayname_old = strtoupper("http_$array_vars");
    $arrayname_new = strtoupper("_$array");
    global ${$arrayname_old};
    if ( is_array(${$arrayname_old}) ) {
      return $arrayname_old;
    }
    return $arrayname_new;
    */
  }

  /**************************************************************************
   * Return serialized version of $array
   * $array = 'get', 'post', 'cookie', 'env', 'server'
   */
  function getSerialized($array) {
    $array = CGI::getArrayName($array);
    global ${$array};
    return serialize(${$array});
  }

  /**************************************************************************
   * Helper for defaulted array-retrieval from global namespace.  If
   * array named $array exists in global namespace and it has key
   * $element, return the value of the corresponding element.
   * Otherwise return $default.
   *
   * FIXME: Somehow this doesn't work with PHP 4.1.2
   **/
  function safeLookup($array, $element, $default=null) {
    global $$array;
    if ( is_array($$array) &&
	 isset(${$array}[$element]) ) {
      return ${$array}[$element];
    } else {
      return $default;
    }
  }

  /**************************************************************************
   * Helper for defaulted array-retrieval from GET variables.
   **/
  function safeLookupGet($element, $default=null) {
    /* Could be done like this
    if ( version_compare(phpversion(), '4.1.0', '<') ) {
      $HTTP_GET_VARS
    } else {
      $_GET
    } */
    global $HTTP_GET_VARS;
    if ( isset($HTTP_GET_VARS[$element]) ) {
      return $HTTP_GET_VARS[$element];
    } else {
      return $default;
    }
  }

  /**************************************************************************
   * Helper for defaulted array-retrieval from GET variables.
   **/
  function safeLookupPost($element, $default=null) {
    global $HTTP_POST_VARS;
    if ( isset($HTTP_POST_VARS[$element]) ) {
      return $HTTP_POST_VARS[$element];
    } else {
      return $default;
    }
  }

  /**************************************************************************
   * Helper for defaulted array-retrieval from GET/POST variables.
   **/
  function safeLookupGP($element, $default=null) {
    /* Old version, not working very well
    $g = CGI::getArrayName('get');
    $p = CGI::getArrayName('post');
    if ( ($retval = CGI::safeLookup($g, $element, $default)) === $default ) {
      return CGI::safeLookup($p, $element, $default);
    } else {
      return $retval;
    } */
    if ( ($retval = CGI::safeLookupGet($element, $default)) === $default ) {
      return CGI::safeLookupPost($element, $default);
    } else {
      return $retval;
    }
  }

  /**************************************************************************
   * Helper for defaulted array-retrieval from SERVER variables.
   **/
  function safeLookupS($element, $default=null) {
    $s = CGI::getArrayName('server');
    return CGI::safeLookup($s, $element, $default);
  }
}
?>
