<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is TopicTree code.
 *
 * The Initial Developer of the Original Code is Miika Nurminen.
 * Portions created by Miika Nurminen are Copyright
 * (C) Miika Nurminen. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

require('generic.php');
require('tree.php');
require('doctree_global.php');
require_once('htmllib.php');
XMLheader();
?>
<!DOCTYPE topicMap SYSTEM "http://www.topicmaps.org/xtm/1.0/xtm1.dtd">
<topicMap xmlns:xlink="http://www.w3.org/1999/xlink" id="bookmarks">
<?php


function persistent_http_variables() {
  global $all;
  return "all=".$all;
}

?>
<?


function toId($s) {
  $from = array("&"," ","(",")",",","+");
  $to   = array("_","_","","","",""); 
  return "id_".expand_amps(str_replace($from,$to,$s));
}


function expand_amps($s) {
  return (str_replace("&","&amp;",$s));
}

function insert_anchor($actname) {
    echo "<a id=\"".$actname."\"></a>\n";
}

function insert_link($docdata,$topicname) {
?>
<topic id="<?=toId($docdata[0]) ?>">
<instanceOf><topicRef xlink:href="#<?=toId($topicname) ?>" /></instanceOf>
<baseName><baseNameString><?=expand_amps($docdata[0]) ?></baseNameString></baseName>
<?php
for ($i=1; $i<count($docdata); $i++) {   
?>
<occurrence><resourceRef xlink:href="<?=expand_amps($docdata[$i]) 
?>"/></occurrence>
<?php
}
?>
</topic>
<?php 
}

function insert_popup($docdata) {
    echo "<li class=\"basic\"> ".$docdata[1]."";
    if (trimlen($docdata[2])>0) {
        echo " - <span class=\"links\">[ ";
?>
<?

        echo "<a target=\"_blank\" 
href=\"".$docdata[2]."\">".strip_html($docdata[2])."</a>";
        echo " ]</span>"; 
?>
<div>
<input type="text" id="button_<?echo $docdata[1];?>" value="" 
onkeypress="test_key(event,'<?echo 
$docdata[3]."',this.value,'".trim($docdata[4])?>')"></input>
<button onclick="open_combined_url('<?echo $docdata[3]."',document.getElementById('button_".$docdata[1]."').value,'".trim($docdata[4])?>')">Go</button>
</div>
<?
    }
    echo "</li>\n";
}


function insertfile($actname,$expand) {
  global $link,$update,$DOM,$all;
  
  $name=docdir().$actname;


  {
    $fp = fopen($name,"r");
    if (!$fp) exit;
    $fline=fgets($fp,400);
?>
<topic id="<?=toId($actname) ?>">
<baseName><baseNameString><?=$fline ?></baseNameString></baseName>
</topic>
<?php
    while (!feof($fp)) {
      $fline=trim(fgets($fp,400));
      if (strlen($fline)<2) break;
      $docdata=explode("|",$fline);
      if ((count($docdata)>1) && ($docdata[0]=="POPUP"))/* insert_popup($docdata)*/;
       else if (count($docdata)>1) insert_link($docdata,$actname);
      else if (count($docdata)>0) { 
      	?>
      	<association>
  <instanceOf><topicRef xlink:href="http://www.topicmaps.org/xtm/1.0/core.xtm#superclass-subclass/" /></instanceOf>
  <member>
    <roleSpec><topicRef xlink:href="http://www.topicmaps.org/xtm/1.0/core.xtm#superclass" /></roleSpec>
    <topicRef xlink:href="#<?=toId($actname) ?>"/>
      </member>
  <member>
    <roleSpec><topicRef xlink:href="http://www.topicmaps.org/xtm/1.0/core.xtm#subclass" /></roleSpec>
    <topicRef xlink:href="#<?=toId($docdata[0]) ?>"/>
    </member>  
    </association>
      	<?php
	    insertfile(trim($docdata[0]),false);
	//	        echo "</ul></li>";
      }
    }
  }
} 
?>        


<? insertfile(rootdoc(),true); ?>

</topicMap>
