/*
 * DomLib.java
 *
 * Copyright (C) 2003 Miika Nurminen
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
import org.w3c.dom.*;

/**
 *
 * @author  Miika Nurminen
 */
public class DomLib {
  
  /** Creates a new instance of DomLib */
  public DomLib() {
  }
  
  public static void copyNodeList(NodeList nlFrom, Node nTo, Document dTo, boolean deep) {
    for (int i=0; i<nlFrom.getLength(); i++) {
      Node temp = dTo.importNode(nlFrom.item(i), deep);
      nTo.appendChild(temp);
    }
  }
  
  /**
   * Recursive copying of nodes from one document to other.
   * @param reclevel recursive level of copying. 0 indicates no recursion.
   */
  public static void copyNodes(Node nFrom, Node nTo, Document dTo, int reclevel) {
    Node temp = dTo.importNode(nFrom,false);
    nTo.appendChild(temp);
    if (reclevel==0) return;
    NodeList nl = nFrom.getChildNodes();
    for (int i=0; i<nl.getLength(); i++) {
      copyNodes(nl.item(i), temp, dTo, reclevel-1);
    }
  }
}
