<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is TopicTree code.
 *
 * The Initial Developer of the Original Code is Miika Nurminen.
 * Portions created by Miika Nurminen are Copyright
 * (C) Miika Nurminen. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

$ini_array=0;

// Returns current filename
function SelfDoc() {
    global $PHP_SELF;
    return $PHP_SELF;
}

// concatenates string. deprecated by .=
function cat($str,$new) {
    return $str.$new;
}

/**
 Appends $new to end of $str, unless $new is already at the end of $str.
 For example: cat_once("test","str") == "teststr"
              cat_once("teststr","str") == "teststr"
              
 MN, 27.1.2003
 */
function cat_once($str,$new) {
  $len1 = strlen($str);
  $len2 = strlen($new);
  if ($len1<$len2) return $str.$new;
  if (strpos($str,$new)==($len1-$len2)) return $str;
  return $str.$new;
}

// Strips off "http://" and end "/" -marks from a valid URL.
function strip_html($s) {
    if (strlen($s)==0) return; // empty string
    $s = trim($s);
    $i = strpos($s,"//");
    if (!is_integer($i)) {  // no "//"
      return $s;
    }

    $s=substr($s,$i+2);
    if ($s[strlen($s)-1]=="/") $s=substr($s,0,strlen($s)-1);
    return $s;
}

function parse_ini($filename) {
    global $ini_array;
    $ini_array=parse_ini_file($filename);
}


// grants all read/write rights to a file. use with caution!
function make_file_available($name) {
    chmod($name,0666);
}

// returns trimmed str length
function trimlen($s) {
    return strlen(trim($s));
}

function XMLheader() {
?><<?echo "?xml version=\"1.0\" encoding=\"ISO-8859-1\"?";?>>
<?
}

function doctype($type) {
    if ($type=="1.0 transitional") {
    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/transitional.dtd"> 
    <?
    }
    else if ($type=="1.0 strict") {
    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/strict.dtd">  
    <?
    }
    else if ($type="1.1") {
    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
    <?
    }
}

// deprecated by array_key_exists since php 4.1.0
function arrayKeyExists($key, $search) {
   if (in_array($key, array_keys($search))) {
       return true;
   } else {
       return false;
   }
}

// returns same id as a variable and anchor. facilitates script-based positioning.
function link_anchor($linkVar,$id) {
  return ( $linkVar."=".$id."#".$id );
}

?>
