<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" indent="yes"/>
<!-- a hack to insert inline dtd to output xml file. 
     needed because touchgraph applet does not use external dtd correctly.
     mn / 2003-08-27
-->
<xsl:template match="/"><xsl:text disable-output-escaping="yes">&lt;!DOCTYPE TOUCHGRAPH_LB [

&lt;!ELEMENT TOUCHGRAPH_LB (NODESET, EDGESET, PARAMETERS)&gt;
&lt;!ELEMENT NODESET (NODE+)&gt;
&lt;!ELEMENT EDGESET (EDGE*)&gt;
&lt;!ELEMENT PARAMETERS (PARAM*)&gt;

&lt;!ELEMENT NODE (NODE_LOCATION?, NODE_LABEL?, NODE_URL?, NODE_HINT?)&gt;

&lt;!ELEMENT NODE_LABEL EMPTY&gt;
&lt;!ELEMENT NODE_URL EMPTY&gt;
&lt;!ELEMENT NODE_HINT EMPTY&gt;
&lt;!ELEMENT NODE_LOCATION EMPTY&gt;

&lt;!ATTLIST TOUCHGRAPH_LB
  version CDATA #REQUIRED &gt;

&lt;!ATTLIST NODE
  nodeID CDATA #REQUIRED &gt;

&lt;!ATTLIST NODE_LOCATION
  visible CDATA #IMPLIED
  x CDATA #IMPLIED
  y CDATA #IMPLIED &gt;

&lt;!ATTLIST NODE_LABEL
  label CDATA #REQUIRED 
  shape CDATA #IMPLIED
  backColor CDATA #IMPLIED 
  textColor CDATA #IMPLIED
  fontSize CDATA #IMPLIED &gt;

&lt;!ATTLIST NODE_URL 
  url CDATA #REQUIRED 
  urlIsLocal CDATA #IMPLIED 
  urlIsXML CDATA #IMPLIED &gt;

&lt;!ATTLIST NODE_HINT 
  hint CDATA #REQUIRED 
  height CDATA #IMPLIED 
  width CDATA #IMPLIED 
  isHTML CDATA #IMPLIED &gt;  

&lt;!ELEMENT EDGE EMPTY&gt;

&lt;!ATTLIST EDGE
  fromID CDATA #REQUIRED
  toID CDATA #REQUIRED 
  length CDATA #IMPLIED 
  color CDATA #IMPLIED 
  type CDATA #IMPLIED
  visible CDATA #IMPLIED &gt;

&lt;!ELEMENT PARAM EMPTY&gt;

&lt;!ATTLIST PARAM
  name CDATA #REQUIRED
  value CDATA #REQUIRED &gt;
]&gt;
</xsl:text>
<xsl:copy-of select="node()"/>
</xsl:template>
</xsl:stylesheet>
